# Generated by Django 3.1.2 on 2020-10-20 13:22

from django.conf import settings
from django.db import migrations, models


def create_domains(apps, schema_editor):
    StudySession = apps.get_model('studies', 'StudySession')
    Domain = apps.get_model('pseudonyms', 'Domain')

    for session in StudySession.objects.all():
        domain = Domain.objects.create(bits=settings.CASTELLUM_SESSION_DOMAIN_BITS)
        session.domain = domain.key
        session.save()


class Migration(migrations.Migration):

    dependencies = [
        ('studies', '0023_study_announce_status_changes'),
        ('pseudonyms', '0002_pseudonym_unique_subject_domain'),
    ]

    operations = [
        migrations.AddField(
            model_name='studysession',
            name='domain',
            field=models.CharField(editable=False, max_length=64, unique=True, null=True),
        ),
        migrations.RunPython(create_domains),
        migrations.AlterField(
            model_name='studysession',
            name='domain',
            field=models.CharField(default=None, editable=False, max_length=64, unique=True),
        ),
    ]
