# Generated by Django 3.0.8 on 2020-08-05 10:07

import castellum.utils
from django.db import migrations, models


def set_slug(apps, schema_editor):
    Subject = apps.get_model('subjects', 'Subject')
    for subject in Subject.objects.all():
        subject.slug = castellum.utils.uuid_str()
        subject.save()


class Migration(migrations.Migration):

    dependencies = [
        ('subjects', '0017_refactor_permissions'),
    ]

    operations = [
        migrations.AddField(
            model_name='subject',
            name='slug',
            field=models.CharField(default='empty', max_length=64, verbose_name='Slug'),
        ),
        migrations.RunPython(set_slug),
        migrations.AlterField(
            model_name='subject',
            name='slug',
            field=models.CharField(default=castellum.utils.uuid_str, max_length=64, unique=True, verbose_name='Slug'),
        ),
    ]
